<?PHP
/*
 * Name: Dispatcher
 * Author: Michal Tatarynowicz (pies /at/ sputnik /dot/ pl)
 * Version: 0.2.0
 * Release date: 2005-04-06
 * Licence: Public Domain
 *
 * Description:
 * Dispatches the request, creating aproppriate models and controllers.
*/

class Dispatcher {
	// private
	var $_config = false;
	var $admin = 0;
	
	function Dispatcher ($config) {
		$this->_config = $config;
	}

	function dispatch ($url) {
		global $_POST, $_GET, $_FILES, $_SESSION;

		$params = $this->_parse_request($url);
		$params['url'] = ereg('(.*)/public/dispatch.php', $_SERVER['SCRIPT_NAME'], $r)? $r[1]: null;
		$params['form'] = $_POST;
		foreach ($_FILES as $name => $data)
			$params['form'][$name] = $data;

		if (isset($params['controller'])) {
			if (class_exists($params['controller'])) {
				$controller = new $params['controller'] ();
				$controller->params = $params;
				$controller->base = $params['url'];
				$controller->admin = (($_SESSION['code'] == md5(date('Y-m-d').'TORT_SECURITY_TOKEN')) || $this->admin);
				if (isset($params['action'])) {
					if (method_exists($controller,$params['action']))
						$controller->$params['action']();
					else
						trigger_error (sprintf(ERROR_NO_ACTION, $params['action'], $params['controller']), E_USER_ERROR);
				}
			}
			else {
				trigger_error (sprintf(ERROR_UNKNOWN_CONTROLLER, $params['controller']), E_USER_ERROR);
			}
		}
		else {
			trigger_error (ERROR_NO_CONTROLLER_SET, E_USER_ERROR);
		}
		
		return $params;
	}
	function _parse_request ($url) {
		$url = '/'.$url;
		foreach ($this->_config as $route) {

			if (preg_match("|^{$route['url']}$|", $url, $regs)) {
				$out = array();
				if (isset($route['default']) && is_array($route['default']))
					foreach ($route['default'] as $key => $value) {
						$out[$key] = $value;
					}

				if (isset($route['set']) && is_array($route['set']))
					foreach ($route['set'] as $name => $id) {
						if (isset($regs[$id]))
							$out[$name] = $regs[$id];
					}

				return $out;
			}
		}		
	}
}

?>