<?PHP

define ('DEBUG', 0);

## TIMING
##
if (DEBUG) {
	function getmicrotime() {
	    list($usec, $sec) = explode(" ", microtime()); 
	    return ((float)$usec + (float)$sec); 
	} 
	$TIME_START = getmicrotime();
}

## DIRECTORIES
##
define ('LIB_DIR', '../lib/');
define ('CONFIG_DIR', '../config/');
define ('MODELS_DIR', '../app/models/');
define ('CONTROLLERS_DIR', '../app/controllers/');
define ('VIEWS_DIR', '../app/views/');

## LOAD IO LIBRARIES
##
require LIB_DIR.'io/dbo.inc';

## LOAD API LIBRARIES
##
require LIB_DIR.'api/debug.inc';
require LIB_DIR.'api/inflector.inc';

## LOAD TORT LIBRARIES
##
require LIB_DIR.'error_messages.inc';
require LIB_DIR.'tort.inc';
require LIB_DIR.'dispatcher.inc';
require LIB_DIR.'controller.inc';
require LIB_DIR.'model.inc';

## LOAD ROUTES
##
require CONFIG_DIR.'routes.inc';

## CONNECT DATABASE
##
if (file_exists(CONFIG_DIR.'database.inc')) {
	require CONFIG_DIR.'database.inc';
	$DB = new DBO ($DATABASE_CONFIG['devel'], DEBUG);
}

## LOAD MODELS
##
foreach (tort_list_modules(MODELS_DIR) as $model_file)
	include MODELS_DIR.$model_file;

## LOAD CONTROLLERS
##
foreach (tort_list_modules(CONTROLLERS_DIR) as $controller_file)
	include CONTROLLERS_DIR.$controller_file;

## START SESSION
##
session_start();

## RUN THE SCRIPT
##
$DISPATCHER = new Dispatcher ($ROUTES_CONFIG);
$DISPATCHER->dispatch($_GET['url']);

## PRINT TIMING
##
if (DEBUG) echo "<!-- ". round(getmicrotime() - $TIME_START, 2) ."s -->";

?>